package com.tfc.efficientroutes;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.TextView;

import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.Marker;


// Clase heredada de AsyncTask para conseguir la informacin de la URL pasada
public class CarregarURL extends AsyncTask<String, Void, String>{	
	private List<Marker> markersList;
	private Context context;
	private GoogleMap mapa;
	private TextView tvDistanceDuration;
	private ProgressDialog dialog;
	
	CarregarURL(List<Marker> markersList, Context context, GoogleMap mapa, TextView tvDistanceDuration, ProgressDialog dialog) {
		this.markersList = markersList;
		this.context = context;
		this.mapa = mapa;
		this.tvDistanceDuration = tvDistanceDuration;
		this.dialog = dialog;
	}
	
	@Override
	protected void onPreExecute() {

		dialog.show(); //Mostramos el dilogo antes de comenzar
    }
	
	// Cargamos los datos en hilo no-UI
	@Override
	protected String doInBackground(String... urlString) {		
			
		String data = "";
		
        InputStream iStream = null;
        HttpURLConnection urlConnection = null;
        try{
                URL url = new URL(urlString[0]);

                // Creando una conexin HTTP para comunicarse con la URL 
                urlConnection = (HttpURLConnection) url.openConnection();

                urlConnection.connect();

                // Leyendo datos de la URL
                iStream = urlConnection.getInputStream();

                BufferedReader br = new BufferedReader(new InputStreamReader(iStream));

                StringBuffer sb  = new StringBuffer();

                String line = "";
                while( ( line = br.readLine())  != null){
                        sb.append(line);
                }
                
                data = sb.toString();

                br.close();

        }catch(Exception e){
                Log.d("Error al leer o conectar con la URL", e.toString());
        }finally{
                try {
					iStream.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
                urlConnection.disconnect();
        }
        return data;
				
	}
	
	// Despus de obtener los datos, se ejecuta en hilo UI
	@Override
	protected void onPostExecute(String result) {			
		super.onPostExecute(result);
		
		CreadorGoogleJSON creadorGoogleJSON = new CreadorGoogleJSON(markersList, context, mapa, tvDistanceDuration, dialog);
		
		// Invoca el hilo para analizar los datos JSON
		creadorGoogleJSON.execute(result);
			
	}		
}
