package com.tfc.efficientroutes;

import java.util.HashMap;
import java.util.List;

import org.json.JSONObject;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;
import android.widget.TextView;

import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.Marker;

// Una clase heredada de AsyncTask para analizar la respuesta del String de Google Places con 
// estructura JSON, pasndolo por la clase InterpretadorGoogleJSON.
public class CreadorGoogleJSON extends AsyncTask<String, Integer, List<List<HashMap<String,String>>> >{
	private List<Marker> markersList;
	private Context context;
	private GoogleMap mapa;
	private TextView tvDistanceDuration;
	private ProgressDialog dialog;
	
	CreadorGoogleJSON(List<Marker> markersList, Context context, GoogleMap mapa, TextView tvDistanceDuration, ProgressDialog dialog) {
		this.markersList = markersList;
		this.context = context;
		this.mapa = mapa;
		this.tvDistanceDuration = tvDistanceDuration;
		this.dialog = dialog;
	}
	
	// Hilo no-UI
	@Override
	protected List<List<HashMap<String, String>>> doInBackground(String... jsonData) {
		
		JSONObject jObject;	
		List<List<HashMap<String, String>>> routes = null;			           
        
        try{
        	jObject = new JSONObject(jsonData[0]);
        	InterpretadorGoogleJSON interpretadorGoogleJSON = new InterpretadorGoogleJSON();
        	
        	// Analizamos los datos
        	routes = interpretadorGoogleJSON.interpretadorGoogleJSON(jObject);    
        }catch(Exception e){
        	e.printStackTrace();
        }
        return routes;
	}
	
	// Despus de obtener los datos, se ejecuta en hilo UI
	@Override
	protected void onPostExecute(List<List<HashMap<String, String>>> result) {
		new DibuixaRuta(result, markersList, context, mapa, tvDistanceDuration, dialog).dibuixaRuta();
	}
}
