package com.tfc.efficientroutes;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.graphics.Color;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.PolylineOptions;

public class DibuixaRuta {
	private List<List<HashMap<String, String>>> result;
	private List<Marker> markersList;
	private Context context;
	private GoogleMap mapa;
	private TextView tvDistanceDuration;
	private ProgressDialog dialog;
	private ArrayList<LatLng> puntos = null;
	private PolylineOptions lineOptions = null;
	private double distancia = 0;
	private int duracion = 0;
	private int rojo = 200;
	private int verde = 255;
	
	DibuixaRuta(List<List<HashMap<String, String>>> result,List<Marker> markersList,
			Context context, GoogleMap mapa, TextView tvDistanceDuration, ProgressDialog dialog) {
		this.result = result;
		this.markersList = markersList;
		this.context = context;
		this.mapa = mapa;
		this.tvDistanceDuration = tvDistanceDuration;
		this.dialog = dialog;
	}
	
	public void dibuixaRuta() {
		int markersNum = markersList.size();
		int intervaloColores = 508/(markersNum + 1);
		rojo = rojo + intervaloColores;
		
    	double latMax = -90;
        double latMin = 90;
        double lngMax = -180;
        double lngMin = 180;
		
		if(result.size() < 1) {
			dialog.dismiss();
			Toast.makeText(context, "No hay una ruta posible", Toast.LENGTH_SHORT).show();
			return;
		}
	
		// Atravesando por todas las rutas
		for (int i = 0; i < result.size(); i++){
			puntos = new ArrayList<LatLng>();
			lineOptions = new PolylineOptions();
			
			// Obteniendo la ruta completa
			List<HashMap<String, String>> path = result.get(i);
	
			// Obteniendo todos los puntos de la ruta
			for (int j = 0; j < path.size(); j++){
				HashMap<String,String> punto = path.get(j);	
				
				if(punto.containsKey("distance")){	// Get distance from the list
					distancia = distancia + Double.parseDouble(punto.get("distance"));			
					
					lineOptions.width(8);
	
					lineOptions.color(Color.rgb(rojo, verde, 255));
					lineOptions.addAll(puntos);
					// Dibujamos la ruta en una polilnea en el mapa
					mapa.addPolyline(lineOptions);
					puntos = new ArrayList<LatLng>();
					lineOptions = new PolylineOptions();
	
					rojo = rojo - intervaloColores;
					if (rojo < 0) {
						verde = verde + rojo;
						rojo = 0;
					}
	
					continue;
					
				}else if(punto.containsKey("duration")){ // Get duration from the list
					duracion = duracion + Integer.parseInt(punto.get("duration"));
					continue;
				}
				
				double lat = Double.parseDouble(punto.get("lat"));
				double lng = Double.parseDouble(punto.get("lng"));
				LatLng posicion = new LatLng(lat, lng);	
				
            	if (lat > latMax) latMax = lat;
                else if (lat < latMin) latMin = lat;
                if (lng > lngMax) lngMax = lng;
                else if (lng < lngMin) lngMin = lng;
				
				puntos.add(posicion);						
			}
			
			// Aadimos todos los puntos de la ruta a la LineOptions para pintar el camino
			lineOptions.width(8);
			lineOptions.color(Color.rgb(rojo, verde, 255));
			lineOptions.addAll(puntos);
			// Dibujamos la ruta en una polilnea en el mapa
			mapa.addPolyline(lineOptions);
		}
		int hora= duracion/3600;  
	    int min=(duracion-(3600*hora))/60;  
	    int seg=duracion-((hora*3600)+(min*60)); 
		dialog.dismiss();
		
		tvDistanceDuration.setText("Distancia: "+Math.rint(distancia/100)/10 + "km - Duracin: "+ hora + "h " + min + "min " + seg + "seg");
		LatLngBounds ltlgbounds = new LatLngBounds(new LatLng(latMin, lngMin), new LatLng(latMax, lngMax));
    	mapa.animateCamera(CameraUpdateFactory.newLatLngBounds(ltlgbounds, 150));

	}
}