package com.tfc.efficientroutes;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.google.android.gms.maps.model.LatLng;

public class InterpretadorGoogleJSON {
	
	// Recibe un objeto JSONObject y devolvemos una lista de listas que contienen los pares clave-valor
	public List<List<HashMap<String,String>>> interpretadorGoogleJSON(JSONObject jasonObject){
		
		List<List<HashMap<String, String>>> rutas = new ArrayList<List<HashMap<String,String>>>() ;
		JSONArray jasonRoutes = null;
		JSONArray jasonLegs = null;
		JSONArray jasonSteps = null;	
		JSONObject distance = null;
		JSONObject duration = null;
		
		try {			
			jasonRoutes = jasonObject.getJSONArray("routes");
			
			// Atravesando todas las rutas
			for (int i = 0; i < jasonRoutes.length(); i++){			
				jasonLegs = ( (JSONObject)jasonRoutes.get(i)).getJSONArray("legs");				
				
				List<HashMap<String, String>> path = new ArrayList<HashMap<String, String>>();				
				
				/** Traversing all legs */
				for (int j = 0; j < jasonLegs.length(); j++){
					
					/** Getting distance from the json data */
					distance = ((JSONObject) jasonLegs.get(j)).getJSONObject("distance");
					HashMap<String, String> hmDistance = new HashMap<String, String>();
					hmDistance.put("distance", distance.getString("value"));
					

					/** Getting duration from the json data */
					duration = ((JSONObject) jasonLegs.get(j)).getJSONObject("duration");
					HashMap<String, String> hmDuration = new HashMap<String, String>();
					hmDuration.put("duration", duration.getString("value"));
					
					/** Adding distance object to the path */
					path.add(hmDistance);
					
					/** Adding duration object to the path */
					path.add(hmDuration);				
									
					jasonSteps = ( (JSONObject)jasonLegs.get(j)).getJSONArray("steps");
					
					/** Traversing all steps */
					for (int k = 0; k < jasonSteps.length(); k++){
						String polyline = "";
						polyline = (String)((JSONObject)((JSONObject)jasonSteps.get(k)).get("polyline")).get("points");
						List<LatLng> list = decodificaPolilinia(polyline);
						
						/** Traversing all points */
						for (int l = 0; l < list.size(); l++){
							HashMap<String, String> hm = new HashMap<String, String>();
							hm.put("lat", Double.toString(((LatLng)list.get(l)).latitude) );
							hm.put("lng", Double.toString(((LatLng)list.get(l)).longitude) );
							path.add(hm);						
						}								
					}					
				}
				rutas.add(path);
			}
			
		} catch (JSONException e) {			
			e.printStackTrace();
		}catch (Exception e){			
		}
		
		return rutas;
	}	
	
	
	/**
	 * Method to decode polyline points 
	 * Courtesy : jeffreysambells.com/2010/05/27/decoding-polylines-from-google-maps-direction-api-with-java 
	 * */
    private List<LatLng> decodificaPolilinia(String encoded) {

        List<LatLng> poly = new ArrayList<LatLng>();
        int index = 0, len = encoded.length();
        int lat = 0, lng = 0;

        while (index < len) {
            int b, shift = 0, result = 0;
            do {
                b = encoded.charAt(index++) - 63;
                result |= (b & 0x1f) << shift;
                shift += 5;
            } while (b >= 0x20);
            int dlat = ((result & 1) != 0 ? ~(result >> 1) : (result >> 1));
            lat += dlat;

            shift = 0;
            result = 0;
            do {
                b = encoded.charAt(index++) - 63;
                result |= (b & 0x1f) << shift;
                shift += 5;
            } while (b >= 0x20);
            int dlng = ((result & 1) != 0 ? ~(result >> 1) : (result >> 1));
            lng += dlng;

            LatLng p = new LatLng((((double) lat / 1E5)),
                    (((double) lng / 1E5)));
            poly.add(p);
        }

        return poly;
    }
}